/*
* Welcome to your app's main JavaScript file!
*
* We recommend including the built version of this JavaScript file
* (and its CSS file) in your base layout (base.html.twig).
*/

// any CSS you import will output into a single css file (app.css in this case)

// start the Stimulus application
//import './bootstrap';

const { default: consolaGlobalInstance } = require('consola');
var Calendar = require('tui-calendar'); /* CommonJS */
var UserLevel = 0;
document.getElementById("userLvl").innerHTML = UserLevel;
console.log(UserLevel);

$(function () {
  var calendar = new Calendar('#calendar', {
    defaultView: 'week',
    taskView: false,
    useCreationPopup: true,
    useDetailPopup: true
  });

  function getStartAndEndDates() {
    let dateStart = String(calendar.getDateRangeStart().toDate()).slice(4, 15);
    document.getElementById("dateStart").innerHTML = dateStart;
    let dateEnd = String(calendar.getDateRangeEnd().toDate()).slice(4, 15);
    document.getElementById("dateEnd").innerHTML = dateEnd;
  }

  getStartAndEndDates();
  var scheduleIds = []
  var currentSchedule = 1

  function sendCalendarData() {
    var schedules = []
    scheduleIds.forEach(function (id) {
      var schedule = calendar.getSchedule(String(id), '1');
      schedules[schedules.length] = schedule
    })


    $.ajax({
      type: "POST",
      url: "/calendar/send",
      data: JSON.stringify(schedules),
      dataType: "json",
      contentType: 'application/json'
    });
  }

  console.log($("#btn-yes-feedback"))
  $("#btn-yes-feedback").on('click', function (event) {
    $.ajax({
      type: "POST",
      url: "/calendar/send_click",
      success: function (data) {
        console.log(data);
        UserLevel = data.score;
        document.getElementById("userLvl").innerHTML = parseInt(UserLevel, 10);
      }
    })
  })

  calendar.on('beforeCreateSchedule', function (event) {
    var scheduleData = event
    // var calendarId = '1';
    var schedule = {
      id: String(currentSchedule),
      calendarId: '1',
      title: scheduleData.title,
      isAllDay: scheduleData.isAllDay,
      start: scheduleData.start,
      end: scheduleData.end,
      category: scheduleData.isAllDay ? 'allday' : 'time',
      dueDateClass: '',
      color: calendar.color,
      bgColor: calendar.bgColor,
      dragBgColor: calendar.bgColor,
      borderColor: calendar.borderColor,
      location: scheduleData.location,
      isPrivate: scheduleData.isPrivate,
      state: scheduleData.state
    };

    scheduleIds[scheduleIds.length] = currentSchedule;
    currentSchedule++;

    calendar.createSchedules([schedule]);

    sendCalendarData();
  });

  calendar.on('beforeDeleteSchedule', function (event) {
    calendar.deleteSchedule(event.schedule.id, event.schedule.calendarId, event.schedule);
    sendCalendarData();
  });

  prevBtn.addEventListener("click", e => {
    calendar.prev();
    getStartAndEndDates();
  });
  nextBtn.addEventListener("click", e => {
    calendar.next();
    sendCalendarData();
    getStartAndEndDates();
  });

  calendar.on('beforeUpdateSchedule', function (event) {
    var schedule = event.schedule;
    var changes = event.changes;

    changes.calendarId = "1"

    calendar.updateSchedule(schedule.id, schedule.calendarId, changes);
    sendCalendarData();
  });


  $.ajax({
    type: "POST",
    url: "/calendar/receive",
    success: function (data) {
      var cleanedData = []
      if (Array.isArray(data)) {
        data.forEach(function (schedule) {
          if (schedule) {
            schedule.start = schedule.start._date
            schedule.end = schedule.end._date
            scheduleIds[scheduleIds.length] = parseInt(schedule.id)
            currentSchedule++
            cleanedData[cleanedData.length] = schedule
          }
        })

        calendar.createSchedules(cleanedData)
      }

    },
  });
});
